<div>
  <div id="subheader">
    <div class="item" id="sadmin">
      <dx-tabs (onInitialized)="onInitTabs($event)" [dataSource]="subnavTabs" [scrollingEnabled]="true"
        [scrollByContent]="true" [showNavButtons]="true" [selectedIndex]="0" (onItemClick)="reloadData($event)">
      </dx-tabs>
    </div>
  </div>
  <br />

  <div [hidden]="current != 'st'">
    <dx-data-grid class="gridContainer" #gridST [allowColumnResizing]='true' [allowColumnReordering]='true'
      [columnAutoWidth]='true' [rowAlternationEnabled]='ds.rowAlternationEnabled' [showColumnLines]='ds.showColumnLines'
      [showRowLines]='ds.showRowLines' [dataSource]='dsStation' (onContentReady)="onContentReady($event)"
      (onToolbarPreparing)='toolbarPreparingStation($event)'>
      <dxo-editing [allowAdding]='true' [allowUpdating]='true' [allowDeleting]='true' [useIcons]='true'></dxo-editing>
      <dxo-export [enabled]='true' fileName='station'></dxo-export>
      <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
      <dxo-search-panel [visible]='true'></dxo-search-panel>
      <dxo-column-chooser [enabled]='true'></dxo-column-chooser>
      <dxo-state-storing [enabled]='true' storageKey='gridStationWST' type="custom" [customLoad]="ds.gridLoadState"
        [customSave]="ds.gridSaveState"></dxo-state-storing>
      <dxo-master-detail [enabled]='true' template='detail'></dxo-master-detail>
      <dxo-selection mode="multiple" showCheckBoxesMode='always'></dxo-selection>

      <dxi-column caption='Code' dataField='code' dataType='string'></dxi-column>
      <dxi-column caption='Name' dataField='name' dataType='string'></dxi-column>
      <dxi-column caption='Address' dataField='addressId' dataType='string'>
        <dxo-lookup [dataSource]='dsStoreAddress' valueExpr='id' [displayExpr]='showAddressDetails'></dxo-lookup>
        <!-- [searchExpr]='["code", "description"]' -->
      </dxi-column>
      <dxi-column caption='Transporter' dataField='transporterId' dataType='string'>
        <dxo-lookup [dataSource]='dsTransporter' valueExpr='id' displayExpr='name'></dxo-lookup>
      </dxi-column>
      <dxi-column caption='User' dataField='userId' dataType='string'>
        <dxo-lookup [dataSource]='dsStationUser' valueExpr='id' displayExpr='loginName'></dxo-lookup>
      </dxi-column>
      <dxi-column caption='Is Active' dataField='isActiv' dataType='boolean'></dxi-column>

      <div *dxTemplate="let s of 'detail'">
        <dx-tab-panel>
          <dxi-item itemTemplate="tabTank" title="Tank">
            <dx-data-grid [columnAutoWidth]='true' [height]='150' [rowAlternationEnabled]='ds.rowAlternationEnabled'
              [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines'
              (onContentReady)='stationInit($event, s, "tank")' (onInitNewRow)='addrNewRow($event)'>
              <dxo-editing [allowAdding]='true' [allowUpdating]='true' [allowDeleting]='true' [useIcons]='true'>
              </dxo-editing>
              <dxo-export [enabled]='true' fileName='tank'></dxo-export>
              <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
              <dxo-search-panel [visible]='true'></dxo-search-panel>

              <dxi-column caption='Cod' dataField='code' dataType='string'></dxi-column>
              <dxi-column caption='Capacity' dataField='capacity' dataType='number'></dxi-column>
              <dxi-column caption='Unusable' dataField='unusable' dataType='number'></dxi-column>
              <dxi-column caption='Product' dataField='productId' dataType='string'>
                <dxo-lookup [dataSource]='dsProduct' valueExpr='id' displayExpr='name'></dxo-lookup>
              </dxi-column>
              <dxi-column caption='Is Active' dataField='isActiv' dataType='boolean'></dxi-column>
            </dx-data-grid>
          </dxi-item>

          <dxi-item itemTemplate="tabStationRange" title="Station Range">
            <dx-data-grid [columnAutoWidth]='true' [height]='150' [rowAlternationEnabled]='ds.rowAlternationEnabled'
              [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines'
              (onContentReady)='stationInit($event, s, "range")' (onInitNewRow)='addNewStationRange($event)'>
              <dxo-editing [allowAdding]='true' [allowUpdating]='true' [allowDeleting]='true' [useIcons]='true'>
              </dxo-editing>
              <dxo-export [enabled]='true' fileName='station'></dxo-export>
              <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
              <dxo-search-panel [visible]='true'></dxo-search-panel>

              <dxi-column caption='Code' dataField="rangeId" dataType="string">
                <dxo-lookup [dataSource]='dsRange' valueExpr='id' [displayExpr]='stationRangeDisplayed'></dxo-lookup>
              </dxi-column>
              <dxi-column caption='Depot' dataField="depotId" dataType="string">
                <dxo-lookup [dataSource]='dsDepot' valueExpr='id' displayExpr='name'></dxo-lookup>
              </dxi-column>
            </dx-data-grid>
          </dxi-item>
        </dx-tab-panel>
      </div>
    </dx-data-grid>
  </div>

  <div [hidden]="current != 'cs'">
    <dx-data-grid class="gridContainer" #gridCS [allowColumnResizing]='true' [allowColumnReordering]='true'
      [columnAutoWidth]='true' [rowAlternationEnabled]='ds.rowAlternationEnabled' [showColumnLines]='ds.showColumnLines'
      [showRowLines]='ds.showRowLines' [dataSource]='dsCustomer' (onContentReady)="onContentReady($event)"
      (onToolbarPreparing)='toolbarPreparing($event)'>
      <dxo-editing [allowAdding]='true' [allowUpdating]='true' [allowDeleting]='true' [useIcons]='true'></dxo-editing>
      <dxo-export [enabled]='true' fileName='customer'></dxo-export>
      <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
      <dxo-search-panel [visible]='true'></dxo-search-panel>
      <dxo-column-chooser [enabled]='true'></dxo-column-chooser>
      <dxo-state-storing [enabled]='true' storageKey='gridCustomerWST' type="custom" [customLoad]="ds.gridLoadState"
        [customSave]="ds.gridSaveState"></dxo-state-storing>
      <dxo-master-detail [enabled]='true' template='detail'></dxo-master-detail>
      <dxo-remote-operations [filtering]="true" [sorting]="true" [paging]="true"></dxo-remote-operations>

      <dxi-column caption='Code' dataField='code' dataType='string'></dxi-column>
      <dxi-column caption='Name' dataField='name' dataType='string'></dxi-column>
      <dxi-column caption='Register No' dataField='registerNo' dataType='string'></dxi-column>
      <dxi-column caption='Fiscal Code' dataField='fiscalCode' dataType='string'></dxi-column>
      <dxi-column caption='Address' dataField='address' dataType='string'></dxi-column>

      <div *dxTemplate="let c of 'detail'">
        <dx-data-grid [columnAutoWidth]='true' [height]='150' [rowAlternationEnabled]='ds.rowAlternationEnabled'
          [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines' (onContentReady)='addrInit($event, c)'
          (onInitNewRow)='addrNewRow($event)'>
          <dxo-editing [allowAdding]='true' [allowUpdating]='true' [allowDeleting]='true' [useIcons]='true'>
          </dxo-editing>
          <dxo-export [enabled]='true' fileName='pos'></dxo-export>
          <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
          <dxo-search-panel [visible]='true'></dxo-search-panel>

          <dxi-column caption='Code' dataField='code' dataType='string'></dxi-column>
          <dxi-column caption='Postal Code' dataField='postalCode' dataType='string'></dxi-column>
          <dxi-column caption='Cost Center' dataField='costCenter' dataType='string'></dxi-column>
          <dxi-column caption='City' dataField='city' dataType='string'></dxi-column>
          <dxi-column caption='Region' dataField='region' dataType='string'></dxi-column>
          <dxi-column caption='Address' dataField='description' dataType='string'></dxi-column>
          <dxi-column caption='CoordX' dataField='coordX' dataType='string'></dxi-column>
          <dxi-column caption='CoordY' dataField='coordY' dataType='string'></dxi-column>
        </dx-data-grid>
      </div>
    </dx-data-grid>
  </div>

  <div [hidden]="current != 'tr'">
    <dx-data-grid class="gridContainer" #gridTR [allowColumnResizing]='true' [allowColumnReordering]='true'
      [columnAutoWidth]='true' [rowAlternationEnabled]='ds.rowAlternationEnabled' [showColumnLines]='ds.showColumnLines'
      [showRowLines]='ds.showRowLines' [dataSource]='dsTransporter' (onContentReady)="onContentReady($event)"
      (onToolbarPreparing)='toolbarPreparing($event)'>
      <dxo-editing [allowAdding]='true' [allowUpdating]='true' [allowDeleting]='true' [useIcons]='true'></dxo-editing>
      <dxo-export [enabled]='true' fileName='transporter'></dxo-export>
      <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
      <dxo-search-panel [visible]='true'></dxo-search-panel>
      <dxo-column-chooser [enabled]='true'></dxo-column-chooser>
      <dxo-state-storing [enabled]='true' storageKey='gridTransporterWST' type="custom" [customLoad]="ds.gridLoadState"
        [customSave]="ds.gridSaveState"></dxo-state-storing>
      <dxo-master-detail [enabled]='true' template='detail'></dxo-master-detail>
      <dxo-remote-operations [filtering]="true" [sorting]="true" [paging]="true"></dxo-remote-operations>

      <dxi-column caption='Code' dataField='code' dataType='string'></dxi-column>
      <dxi-column caption='Name' dataField='name' dataType='string'></dxi-column>
      <dxi-column caption='Address' dataField='name' dataType='string'></dxi-column>
      <dxi-column caption='Email' dataField='email' dataType='string'></dxi-column>
      <dxi-column caption='Phone' dataField='phone' dataType='string'></dxi-column>
      <dxi-column caption='Contact Name' dataField='contactName' dataType='string'></dxi-column>

      <div *dxTemplate="let t of 'detail'">
        <dx-tab-panel [items]="transTabs">
          <div *dxTemplate="let tab of 'tabCar'">
            <dx-data-grid [columnAutoWidth]='true' height='350px' [rowAlternationEnabled]='ds.rowAlternationEnabled'
              [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines'
              (onContentReady)='carInit($event, t)' (onInitNewRow)='trNewRow($event)'>
              <dxo-editing [allowAdding]='true' [allowUpdating]='true' [allowDeleting]='false' [useIcons]='true'>
              </dxo-editing>
              <dxo-export [enabled]='true' fileName='car'></dxo-export>
              <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
              <dxo-search-panel [visible]='true'></dxo-search-panel>

              <dxi-column caption='Registration No' dataField='registrationNo' dataType='string'></dxi-column>
              <dxi-column caption='Driver' dataField='driverId' dataType='string'>
                <dxo-lookup [dataSource]='dsDriver' valueExpr='id' [displayExpr]='displayDriver'></dxo-lookup>
              </dxi-column>
              <dxi-column caption='Trailer' dataField='tankId' dataType='string'>
                <dxo-lookup [dataSource]='dsTank' valueExpr='id' displayExpr='registrationNo'></dxo-lookup>
              </dxi-column>
              <dxi-column caption='Is Active' dataField='isActiv' dataType='boolean'></dxi-column>
            </dx-data-grid>
          </div>
          <div *dxTemplate="let tab of 'tabTank'">
            <dx-data-grid [columnAutoWidth]='true' height='350px' [rowAlternationEnabled]='ds.rowAlternationEnabled'
              [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines'
              (onContentReady)='tankInit($event, t)' (onInitNewRow)='trNewRow($event)'>
              <dxo-editing [allowAdding]='true' [allowUpdating]='true' [allowDeleting]='true' [useIcons]='true'>
              </dxo-editing>
              <dxo-export [enabled]='true' fileName='tank'></dxo-export>
              <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
              <dxo-search-panel [visible]='true'></dxo-search-panel>

              <dxi-column caption='Registration No' dataField='registrationNo' dataType='string'></dxi-column>
              <dxi-column caption='Capacity (Liters)' dataField='capacity' dataType='number'></dxi-column>
              <dxi-column caption='Capacity (Tones)' dataField='capacityTones' dataType='number'></dxi-column>
              <dxi-column caption='Type' dataField='typeId'>
                <dxo-lookup [dataSource]='dsMeterType' valueExpr='id' displayExpr='name'></dxo-lookup>
              </dxi-column>
              <dxi-column caption='Is Active' dataField='isActiv' dataType='boolean'></dxi-column>
            </dx-data-grid>
          </div>
          <div *dxTemplate="let tab of 'tabDriver'">
            <dx-data-grid [columnAutoWidth]='true' height='350px' [rowAlternationEnabled]='ds.rowAlternationEnabled'
              [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines'
              (onContentReady)='driverInit($event, t)' (onInitNewRow)="driverNewRow($event)">
              <dxo-editing [allowAdding]='true' [allowUpdating]='true' [allowDeleting]='true' [useIcons]='true'>
              </dxo-editing>
              <dxo-export [enabled]='true' fileName='driver'></dxo-export>
              <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
              <dxo-search-panel [visible]='true'></dxo-search-panel>

              <dxi-column caption='First Name' dataField='firstName' dataType='string'></dxi-column>
              <dxi-column caption='Last Name' dataField='lastName' dataType='string'></dxi-column>
              <dxi-column caption='ID Card' dataField='idCard' dataType='string'></dxi-column>
              <dxi-column caption='Personal Identification Number' dataField='pin' dataType='string'></dxi-column>
              <dxi-column caption='Phone' dataField='phone' dataType='string'></dxi-column>
              <dxi-column caption='Is Active' dataField='isActiv' dataType='boolean'></dxi-column>
            </dx-data-grid>
          </div>
          <div *dxTemplate="let tab of 'tabCost'">
            <dx-data-grid [columnAutoWidth]='true' height='350px' [rowAlternationEnabled]='ds.rowAlternationEnabled'
              [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines'
              (onContentReady)='costInit($event, t)' (onInitNewRow)='costNewRow($event)'>
              <dxo-editing [allowAdding]='true' [allowUpdating]='true' [allowDeleting]='true' [useIcons]='true'>
              </dxo-editing>
              <dxo-export [enabled]='true' fileName='driver'></dxo-export>
              <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
              <dxo-search-panel [visible]='true'></dxo-search-panel>
              <dxo-group-panel [visible]='true' [allowColumnDragging]='false'></dxo-group-panel>

              <dxi-column caption='Range' dataField="rangeId" dataType="string">
                <dxo-lookup [dataSource]='dsRange' valueExpr='id' [displayExpr]='stationRangeDisplayed'></dxo-lookup>
              </dxi-column>
              <dxi-column caption='Depot' dataField='depotId' dataType='string' groupIndex='0' [showWhenGrouped]='true'>
                <dxo-lookup [dataSource]="dsDepot" valueExpr='id' displayExpr='name'></dxo-lookup>
              </dxi-column>
              <dxi-column caption='Cost/km [EUR]' dataField='value' dataType='number'></dxi-column>
              <dxi-column caption='From date' dataField='fromDate' dataType='date' groupIndex='1'
                [showWhenGrouped]='true'></dxi-column>
            </dx-data-grid>
          </div>
        </dx-tab-panel>
      </div>
    </dx-data-grid>
  </div>

  <div [hidden]="current != 'dep'">
    <dx-data-grid class="gridContainer" #gridDep [columnAutoWidth]='true' [dataSource]='dsDepot'
      (onContentReady)="onContentReady($event)" [rowAlternationEnabled]='ds.rowAlternationEnabled'
      [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines'>
      <dxo-editing [allowAdding]='true' [allowUpdating]='true' [allowDeleting]='true' [useIcons]='true'></dxo-editing>
      <dxo-export [enabled]='true' fileName='depot'></dxo-export>
      <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
      <dxo-search-panel [visible]='true'></dxo-search-panel>
      <dxo-column-chooser [enabled]='true'></dxo-column-chooser>
      <dxo-state-storing [enabled]='true' storageKey='gridDepotWST' type="custom" [customLoad]="ds.gridLoadState"
        [customSave]="ds.gridSaveState"></dxo-state-storing>

      <dxi-column caption='Code' dataField='code' dataType='string'></dxi-column>
      <dxi-column caption='Name' dataField='name' dataType='string'></dxi-column>
      <dxi-column caption='Address' dataField='address' dataType='string'></dxi-column>
      <dxi-column caption='Cost Center' dataField='costCenter' dataType='string'></dxi-column>
      <dxi-column caption='CoordX' dataField='coordX' dataType='string'></dxi-column>
      <dxi-column caption='CoordY' dataField='coordY' dataType='string'></dxi-column>
      <dxi-column caption='Is Virtual' dataField='isVirtual' dataType='boolean'></dxi-column>
    </dx-data-grid>
  </div>

  <div [hidden]="current != 'prod'">
    <dx-data-grid class="gridContainer" #gridProd [columnAutoWidth]='true' [dataSource]='dsProduct'
      (onContentReady)="onContentReady($event)" [rowAlternationEnabled]='ds.rowAlternationEnabled'
      [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines'>
      <dxo-editing [allowAdding]='true' [allowUpdating]='true' [allowDeleting]='true' [useIcons]='true'></dxo-editing>
      <dxo-export [enabled]='true' fileName='product'></dxo-export>
      <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
      <dxo-search-panel [visible]='true'></dxo-search-panel>
      <dxo-column-chooser [enabled]='true'></dxo-column-chooser>
      <dxo-state-storing [enabled]='true' storageKey='gridProductWST' type="custom" [customLoad]="ds.gridLoadState"
        [customSave]="ds.gridSaveState"></dxo-state-storing>

      <dxi-column caption='Code' dataField='code' dataType='string'></dxi-column>
      <dxi-column caption='Hois Code' dataField='hoisCode' dataType='string'></dxi-column>
      <dxi-column caption='Name' dataField='name' dataType='string'></dxi-column>
      <dxi-column caption='Description' dataField='description' dataType='string'></dxi-column>
    </dx-data-grid>
  </div>

  <div [hidden]="current != 'ot'">
    <dx-data-grid class="gridContainer" #gridOT [columnAutoWidth]='true' [dataSource]='dsOrderType'
      (onContentReady)="onContentReady($event)" [rowAlternationEnabled]='ds.rowAlternationEnabled'
      [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines'>
      <dxo-editing [allowAdding]='true' [allowUpdating]='true' [allowDeleting]='true' [useIcons]='true'></dxo-editing>
      <dxo-export [enabled]='true' fileName='orderType'></dxo-export>
      <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
      <dxo-search-panel [visible]='true'></dxo-search-panel>
      <dxo-column-chooser [enabled]='true'></dxo-column-chooser>
      <dxo-state-storing [enabled]='true' storageKey='gridOrderTypeWST' type="custom" [customLoad]="ds.gridLoadState"
        [customSave]="ds.gridSaveState"></dxo-state-storing>

      <dxi-column caption='Name' dataField='name' dataType='string'></dxi-column>
      <dxi-column caption='Customer' dataField='customerId' dataType='string'>
        <dxo-lookup [dataSource]='dsCustomer' valueExpr='id' displayExpr='name'>
        </dxo-lookup>
      </dxi-column>
      <dxi-column caption='Transporter' dataField='transporterId' dataType='string'>
        <dxo-lookup [dataSource]='dsTransporter' valueExpr='id' displayExpr='name'>
        </dxo-lookup>
      </dxi-column>
      <dxi-column caption='Description' dataField='description' dataType='string'></dxi-column>
    </dx-data-grid>
  </div>

  <div [hidden]="current != 'ad'">
    <dx-data-grid class="gridContainer" #gridAD [columnAutoWidth]='true' [dataSource]='dsAudit'
      (onContentReady)="onContentReady($event)" [rowAlternationEnabled]='ds.rowAlternationEnabled'
      [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines'
      (onToolbarPreparing)="toolbarPreparing($event)">
      <dxo-export [enabled]='true' fileName='audit'></dxo-export>
      <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
      <dxo-search-panel [visible]='true'></dxo-search-panel>
      <dxo-column-chooser [enabled]='true'></dxo-column-chooser>
      <dxo-state-storing [enabled]='true' storageKey='gridAuditWST' type="custom" [customLoad]="ds.gridLoadState"
        [customSave]="ds.gridSaveState"></dxo-state-storing>
      <dxo-remote-operations [filtering]="true" [sorting]="true" [paging]="true"></dxo-remote-operations>

      <dxi-column caption='User' dataField='userName' dataType='string'></dxi-column>
      <dxi-column caption='Event Date' dataField='eventDate' dataType='date' calculateSortValue='eventDate'
        [calculateDisplayValue]='ds.getDateTime'>
      </dxi-column>
      <dxi-column caption='Description' dataField='description' dataType='string'></dxi-column>
    </dx-data-grid>
  </div>

  <div [hidden]="current != 'at'">
    <dx-data-grid class="gridContainer" #gridAT [columnAutoWidth]='true' [dataSource]='dsAlert'
      (onContentReady)="onContentReady($event)" [rowAlternationEnabled]='ds.rowAlternationEnabled'
      [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines'
      (onToolbarPreparing)="toolbarPreparing($event)">
      <dxo-export [enabled]='true' fileName='audit'></dxo-export>
      <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
      <dxo-search-panel [visible]='true'></dxo-search-panel>
      <dxo-column-chooser [enabled]='true'></dxo-column-chooser>
      <dxo-state-storing [enabled]='true' storageKey='gridAuditWST' type="custom" [customLoad]="ds.gridLoadState"
        [customSave]="ds.gridSaveState"></dxo-state-storing>
      <dxo-remote-operations [filtering]="true" [sorting]="true" [paging]="true"></dxo-remote-operations>

      <dxi-column caption='Type' dataField='type' dataType='number'>
        <dxo-lookup [dataSource]="dsAlertType" valueExpr="id" displayExpr="val"></dxo-lookup>
      </dxi-column>
      <dxi-column caption='Event Date' dataField='eventDate' dataType='date' calculateSortValue='eventDate'
        [calculateDisplayValue]='ds.getDateTime'>
      </dxi-column>
      <dxi-column caption='Description' dataField='description' dataType='string' width='60%'></dxi-column>
      <dxi-column caption='Is Sent' dataField='isSend' dataType='boolean'></dxi-column>
      <dxi-column caption='Send to' dataField='userId' dataType='string'>
        <dxo-lookup [dataSource]="dsUser" valueExpr="id" displayExpr="emailAddress"></dxo-lookup>
      </dxi-column>
    </dx-data-grid>
  </div>

  <div [hidden]="current != 'cf'">
    <dx-data-grid class="gridContainer" #gridCF [columnAutoWidth]='true' [dataSource]='dsConfig'
      (onContentReady)="onContentReady($event)" [rowAlternationEnabled]='ds.rowAlternationEnabled'
      [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines'
      (onToolbarPreparing)="toolbarPreparing($event)">
      <dxo-export [enabled]='true' fileName='config'></dxo-export>
      <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
      <dxo-search-panel [visible]='true'></dxo-search-panel>
      <!-- <dxo-editing [insertEnabled]='true' [editEnabled]='true' [removeEnabled]='true' [useIcons]='true'></dxo-editing> -->
      <dxo-editing mode='form' [allowAdding]='true' [allowUpdating]='true' [allowDeleting]='true' [useIcons]='true'>
      </dxo-editing>

      <dxi-column caption='Key' dataField='key' dataType='string'>
        <dxi-validation-rule type="required"></dxi-validation-rule>
      </dxi-column>
      <dxi-column caption='Value' dataField='value' dataType='string'>
        <dxi-validation-rule type="required"></dxi-validation-rule>
      </dxi-column>
    </dx-data-grid>
  </div>

  <div [hidden]="current != 'us'">
    <dx-data-grid class="gridContainer" #gridUS [columnAutoWidth]='true' [dataSource]='dsUser'
      (onContentReady)="onContentReady($event)" [rowAlternationEnabled]='ds.rowAlternationEnabled'
      [showColumnLines]='ds.showColumnLines' [showRowLines]='ds.showRowLines' (onInitNewRow)='userNewRow($event)'
      (onEditorPreparing)="editorPreparing($event)" (onRowUpdating)='onUserChanged($event)'
      (onRowInserting)='onUserChanged($event)'>
      <dxo-editing mode="form" [allowAdding]='true' [allowUpdating]='true' [allowDeleting]='false' [useIcons]='true'>
      </dxo-editing>
      <dxo-export [enabled]='true' fileName='user'></dxo-export>
      <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='false'></dxo-scrolling>
      <dxo-header-filter [visible]='true'></dxo-header-filter>
      <dxo-search-panel [visible]='true'></dxo-search-panel>
      <dxo-column-chooser [enabled]='true'></dxo-column-chooser>
      <dxo-state-storing [enabled]='true' storageKey='gridUsersWST' type="custom" [customLoad]="ds.gridLoadState"
        [customSave]="ds.gridSaveState"></dxo-state-storing>

      <dxi-column caption='Login Name' dataField='loginName' dataType='string'>
        <dxi-validation-rule type="required"></dxi-validation-rule>
      </dxi-column>
      <dxi-column caption='Password' dataField='correctPassword' dataType='string' [visible]='false'>
        <dxo-form-item [visible]='true'></dxo-form-item>
        <dxi-validation-rule type="stringLength" [min]="5" [max]="32"
          message="Passowrd must be between 5 and 32 chars."></dxi-validation-rule>
      </dxi-column>
      <dxi-column caption='Full Name' dataField='fullName' dataType='string'>
        <dxi-validation-rule type="required"></dxi-validation-rule>
      </dxi-column>
      <dxi-column caption='Email' dataField='emailAddress' dataType='string'></dxi-column>
      <dxi-column caption='Type' dataField='typeId' dataType='string'>
        <dxo-lookup [dataSource]=' dsUserType' valueExpr='id' displayExpr='type'></dxo-lookup>
        <dxi-validation-rule type="required"></dxi-validation-rule>
      </dxi-column>
      <dxi-column caption='Driver' dataField='driverId' dataType='string' editCellTemplate="templateDriver">
        <dxo-lookup [dataSource]='dsDrivers' allowClearing='true' valueExpr='id' [displayExpr]='displayDriver'>
        </dxo-lookup>
        <!-- [searchExpr]='["lastName", "firstName"]' -->
        <div *dxTemplate="let data of 'templateDriver'">
          <dx-select-box [dataSource]='dsDrivers' (onValueChanged)="onDriverSelCh($event, data)" showClearButton='true'
            [(value)]="data.value" valueExpr='id' [displayExpr]='displayDriver' searchEnabled='true'
            [searchExpr]='["lastName", "firstName"]'></dx-select-box>
        </div>
      </dxi-column>
      <dxi-column caption='Transport' dataField='transporterId'>
        <dxo-lookup [dataSource]='dsTransporter' allowClearing='true' valueExpr='id' displayExpr='name'></dxo-lookup>
      </dxi-column>
      <dxi-column caption='Station' dataField='stationId'>
        <dxo-lookup [dataSource]='dsStation' allowClearing='true' valueExpr='id' displayExpr='name'></dxo-lookup>
      </dxi-column>
      <dxi-column caption='Is Activ' dataField='isActiv' width="80px"></dxi-column>
      <dxi-column caption='Allow Calor' dataField='allowCalor' width="80px"></dxi-column>
    </dx-data-grid>
  </div>
</div>